package str.playerwarps.commands;

import org.bukkit.event.*;
import str.playerwarps.*;
import org.bukkit.command.*;
import org.bukkit.entity.*;
import str.playerwarps.listener.*;
import java.text.*;
import org.bukkit.potion.*;
import org.apache.commons.lang.*;
import org.bukkit.inventory.*;
import str.playerwarps.util.*;
import java.util.regex.*;
import org.bukkit.*;
import java.util.*;
import org.bukkit.inventory.meta.*;

public class Commands implements CommandExecutor, Listener
{
    static PlayerWarps plugin;
    public static ArrayList<String> warpqueue;
    private String help;
    private String usageWC;
    private String usageWCB;
    private static String noPerms;

    public Commands(final PlayerWarps instance) {
        this.help = "&e=== &6WarpCreate Help-Menu &e===";
        this.usageWC = "&eUsage: &f/&ewarpcreate &6<create, delete, fix, approve, approveconfirm, warpqueue, commandAdd, commandDel, reload> &e(warpqueue-page-#) (command) &e(<10m, 20m, 30m, 90m>) (<player>).";
        this.usageWCB = "&eUsage: &f/&ewarpcreateblock &6giveBlock <10m, 20m, 30m, 90m> <player>&e.";
        Commands.plugin = instance;
    }

    public boolean onCommand(final CommandSender sender, final Command cmd, final String label, final String[] args) {
        if (cmd.getName().equalsIgnoreCase("warpcreate")) {
            if (sender instanceof ConsoleCommandSender) {
                Utils.sendConsoleMessage("&cYou cannot use this command in console.");
            }
            else if (!sender.hasPermission("core.warpcreates")) {
                Utils.sendMessage(sender, Commands.noPerms);
            }
            else {
                if (args.length == 0) {
                    this.helpMenu(sender);
                    return false;
                }
                if (args.length == 1) {
                    if (args[0].equalsIgnoreCase("reload")) {
                        if (!sender.hasPermission("core.warpcreates.reload")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                        }
                        else {
                            PlayerWarps.get().reloadConfig();
                            Utils.sendMessage(sender, "&aSuccessfully reloaded PlayerWarps.");
                        }
                    }
                    else if (args[0].equalsIgnoreCase("warpqueue")) {
                        if (sender.hasPermission("core.warpcreate.warpqueue")) {
                            Utils.sendMessage(sender, "&cPlease enter a page number.");
                            return false;
                        }
                        Utils.sendMessage(sender, Commands.noPerms);
                    }
                    else if (args[0].equalsIgnoreCase("create")) {
                        if (!sender.hasPermission("core.warpcreates.create")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                            return false;
                        }
                        this.helpMenu(sender);
                        return false;
                    }
                    else if (args[0].equalsIgnoreCase("delete")) {
                        if (!sender.hasPermission("core.warpcreates.delete")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                            return false;
                        }
                        this.helpMenu(sender);
                        return false;
                    }
                    else if (args[0].equalsIgnoreCase("fix")) {
                        if (!sender.hasPermission("core.warpcreates.fix")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                            return false;
                        }
                        this.helpMenu(sender);
                        return false;
                    }
                }
                else if (args.length == 4) {
                    if (args[0].equalsIgnoreCase("create")) {
                        if (!sender.hasPermission("core.warpcreates.create")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                        }
                        else if (args[1] != null) {
                            if (!args[2].equalsIgnoreCase("h") && !args[2].equalsIgnoreCase("m") && !args[2].equalsIgnoreCase("s")) {
                                Utils.sendMessage(sender, "&cYou can only use 1 time span in warpcreation.");
                                return false;
                            }
                            final Player target = Bukkit.getPlayer(args[3].toString());
                            final Player player = (Player)sender;
                            if (target != null) {
                                if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + target.getUniqueId().toString()) != null) {
                                    if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target.getUniqueId().toString() + ".Building").equalsIgnoreCase("false")) {
                                        final Pattern pattern = Pattern.compile("[^0-9 ]");
                                        final Matcher match = pattern.matcher(args[1]);
                                        final boolean found = match.find();
                                        if (found) {
                                            Utils.sendMessage(sender, "&cError: the time is not alphabetic nor symbolized.");
                                            return false;
                                        }
                                        int time = 0;
                                        if (args[2].equalsIgnoreCase("h")) {
                                            time = Integer.parseInt(args[1]) * 3600;
                                        }
                                        else if (args[2].equalsIgnoreCase("m")) {
                                            time = Integer.parseInt(args[1]) * 60;
                                        }
                                        else if (args[2].equalsIgnoreCase("s")) {
                                            time = Integer.parseInt(args[1]);
                                        }
                                        PlayerWarps.getWorldSetup();
                                        WorldListener.createWarp(target);
                                        final Date now = new Date();
                                        final SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss a");
                                        Utils.saveEditTime(target.getUniqueId().toString(), time, "(+" + args[1] + args[2] + ") " + format.format(now), "true");
                                        Utils.sendMessage(sender, "&eYou've successfully added &6" + args[1] + args[2] + " &eof edit time to &6" + target.getName() + "'s warp.");
                                        Utils.sendMessage((CommandSender)target, "&6" + args[1] + args[2] + " &eof edit time has been successfully added to your warp.");
                                        Utils.sendMessage((CommandSender)target, "&eYou may start editing your warp by accessing the &6control panel &eblock at your warp.");
                                        Utils.sendMessage((CommandSender)target, "&eTo go to your warp issue the follow command: &6/pw " + target.getName());
                                    }
                                    else {
                                        Utils.sendMessage(sender, "&cYou cannot add edit time to &6" + target.getName() + "'s &cwarp as they are building.");
                                    }
                                }
                                else if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + target.getUniqueId().toString()) == null) {
                                    final Pattern pattern = Pattern.compile("[^0-9 ]");
                                    final Matcher match = pattern.matcher(args[1]);
                                    final boolean found = match.find();
                                    if (found) {
                                        Utils.sendMessage(sender, "&cError: the time is not alphabetic nor symbolized.");
                                        return false;
                                    }
                                    int time = 0;
                                    if (args[2].equalsIgnoreCase("h")) {
                                        time = Integer.parseInt(args[1]) * 3600;
                                    }
                                    else if (args[2].equalsIgnoreCase("m")) {
                                        time = Integer.parseInt(args[1]) * 60;
                                    }
                                    else if (args[2].equalsIgnoreCase("s")) {
                                        time = Integer.parseInt(args[1]);
                                    }
                                    PlayerWarps.getWorldSetup();
                                    WorldListener.createWarp(target);
                                    final Date now = new Date();
                                    final SimpleDateFormat format = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss a");
                                    Utils.saveEditTime(target.getUniqueId().toString(), time, "(+" + args[1] + args[2] + ") " + format.format(now), "true");
                                    Utils.sendMessage(sender, "&eYou've successfully &a&lcreated &eand added &6" + args[1] + args[2] + " &eof edit time to &6" + target.getName() + "'s warp.");
                                    Utils.sendMessage((CommandSender)target, "&eYour warp has successfully been &a&lcreated &eand &6" + args[1] + args[2] + " &eof edit time has been added to your warp.");
                                    Utils.sendMessage((CommandSender)target, "&eYou may start editing your warp by accessing the &6control panel &eblock at your warp.");
                                    Utils.sendMessage((CommandSender)target, "&eTo go to your warp issue the follow command: &6/pw " + target.getName());
                                }
                            }
                            else {
                                final OfflinePlayer target2 = Bukkit.getOfflinePlayer(args[3].toString());
                                if (target2 == null) {
                                    Utils.sendMessage(sender, "&cError: This player has never joined the server");
                                    return false;
                                }
                                if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + target2.getUniqueId().toString()) != null) {
                                    final Pattern pattern2 = Pattern.compile("[^0-9 ]");
                                    final Matcher match2 = pattern2.matcher(args[1]);
                                    final boolean found2 = match2.find();
                                    if (found2) {
                                        Utils.sendMessage(sender, "&cError: the time is not alphabetic nor symbolized.");
                                        return false;
                                    }
                                    int time2 = 0;
                                    if (args[2].equalsIgnoreCase("h")) {
                                        time2 = Integer.parseInt(args[1]) * 3600;
                                    }
                                    else if (args[2].equalsIgnoreCase("m")) {
                                        time2 = Integer.parseInt(args[1]) * 60;
                                    }
                                    else if (args[2].equalsIgnoreCase("s")) {
                                        time2 = Integer.parseInt(args[1]);
                                    }
                                    PlayerWarps.getWorldSetup();
                                    WorldListener.createWarp(target);
                                    final Date now2 = new Date();
                                    final SimpleDateFormat format2 = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss a");
                                    Utils.saveEditTime(target2.getUniqueId().toString(), time2, "(+" + args[1] + args[2] + ") " + format2.format(now2), "true");
                                    Utils.sendMessage(sender, "&eYou've successfully added &6" + args[1] + args[2] + " &eof edit time to &6" + target2.getName() + "'s warp.");
                                }
                                else if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + target2.getUniqueId().toString()) == null) {
                                    final Pattern pattern2 = Pattern.compile("[^0-9 ]");
                                    final Matcher match2 = pattern2.matcher(args[1]);
                                    final boolean found2 = match2.find();
                                    if (found2) {
                                        Utils.sendMessage(sender, "&cError: the time is not alphabetic nor symbolized.");
                                        return false;
                                    }
                                    int time2 = 0;
                                    if (args[2].equalsIgnoreCase("h")) {
                                        time2 = Integer.parseInt(args[1]) * 3600;
                                    }
                                    else if (args[2].equalsIgnoreCase("m")) {
                                        time2 = Integer.parseInt(args[1]) * 60;
                                    }
                                    else if (args[2].equalsIgnoreCase("s")) {
                                        time2 = Integer.parseInt(args[1]);
                                    }
                                    PlayerWarps.getWorldSetup();
                                    WorldListener.createWarp(target);
                                    final Date now2 = new Date();
                                    final SimpleDateFormat format2 = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss a");
                                    Utils.saveEditTime(target2.getUniqueId().toString(), time2, "(+" + args[1] + args[2] + ") " + format2.format(now2), "true");
                                    Utils.sendMessage(sender, "&eYou've successfully &a&lcreated &eand added &6" + args[1] + args[2] + " &eof edit time to &6" + target2.getName() + "'s warp.");
                                }
                            }
                        }
                        else {
                            this.helpMenu(sender);
                        }
                    }
                    else {
                        this.helpMenu(sender);
                    }
                }
                else if (args.length == 3) {
                    if (args[0].equalsIgnoreCase("warpqueue")) {
                        if (sender.hasPermission("core.warpcreate.warpqueue")) {
                            Utils.sendMessage(sender, "&cPlease enter a page number.");
                            return false;
                        }
                        Utils.sendMessage(sender, Commands.noPerms);
                    }
                    else {
                        this.helpMenu(sender);
                    }
                }
                else if (args.length == 2) {
                    if (args[0].equalsIgnoreCase("create")) {
                        if (!sender.hasPermission("core.warpcreates.create")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                            return false;
                        }
                        this.helpMenu(sender);
                        return false;
                    }
                    else if (args[0].equalsIgnoreCase("commandDel")) {
                        if (!sender.hasPermission("core.warpcreates.commandDel")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                            return false;
                        }
                        this.helpMenu(sender);
                        return false;
                    }
                    else if (args[0].equalsIgnoreCase("commandAdd")) {
                        if (!sender.hasPermission("core.warpcreates.commandAdd")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                            return false;
                        }
                        this.helpMenu(sender);
                        return false;
                    }
                    else if (args[0].equalsIgnoreCase("delete")) {
                        if (!sender.hasPermission("core.warpcreates.delete")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                        }
                        else {
                            final Player target = Bukkit.getPlayer(args[1]);
                            final Player player = (Player)sender;
                            if (target != null) {
                                if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + target.getUniqueId().toString()) != null) {
                                    Utils.removeWarp(target.getUniqueId().toString());
                                    PlayerWarps.get().reloadConfig();
                                    if (Bukkit.getWorld(PlayerWarps.get().getCustomData().getString("Main-world")) != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
                                        target.teleport(Bukkit.getWorld(PlayerWarps.get().getCustomData().getString("Main-world")).getSpawnLocation());
                                        target.setGameMode(GameMode.SURVIVAL);
                                        target.getInventory().clear();
                                        for (final PotionEffect effects : target.getActivePotionEffects()) {
                                            target.removePotionEffect(effects.getType());
                                        }
                                    }
                                    Utils.sendMessage(sender, "&6" + target.getName() + "'s &eplayerwarp has been deleted!");
                                }
                                else {
                                    Utils.sendMessage(sender, "&6" + target.getName() + " &edoesn't have a playerwarp.");
                                }
                            }
                            else {
                                final OfflinePlayer target2 = Bukkit.getOfflinePlayer(args[1]);
                                if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + target2.getUniqueId().toString()) != null) {
                                    Utils.removeWarp(target2.getUniqueId().toString());
                                    PlayerWarps.get().reloadConfig();
                                    Utils.sendMessage(sender, "&6" + target2.getName() + "'s &eplayerwarp has been deleted!");
                                }
                                else {
                                    Utils.sendMessage(sender, "&6" + target2.getName() + " &edoesn't have a playerwarp.");
                                }
                            }
                        }
                    }
                    else if (args[0].equalsIgnoreCase("fix")) {
                        if (!sender.hasPermission("core.warpcreates.fix")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                        }
                        else {
                            final Player target = Bukkit.getPlayer(args[1]);
                            final Player player = (Player)sender;
                            if (target != null) {
                                if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + target.getUniqueId().toString()) != null) {
                                    Utils.fixWarp(target.getUniqueId().toString());
                                    PlayerWarps.get().reloadConfig();
                                    if (Bukkit.getWorld(PlayerWarps.get().getCustomData().getString("Main-world")) != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
                                        target.teleport(Bukkit.getWorld(PlayerWarps.get().getCustomData().getString("Main-world")).getSpawnLocation());
                                        target.setGameMode(GameMode.SURVIVAL);
                                        target.getInventory().clear();
                                        for (final PotionEffect effects : target.getActivePotionEffects()) {
                                            target.removePotionEffect(effects.getType());
                                        }
                                    }
                                    Utils.sendMessage(sender, "&6" + target.getName() + "'s &eplayerwarp was put in ready to build state (Fixed if broken)!");
                                }
                                else {
                                    Utils.sendMessage(sender, "&6" + target.getName() + " &edoesn't have a playerwarp.");
                                }
                            }
                            else {
                                final OfflinePlayer target2 = Bukkit.getOfflinePlayer(args[1]);
                                if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + target2.getUniqueId().toString()) != null) {
                                    Utils.fixWarp(target2.getUniqueId().toString());
                                    PlayerWarps.get().reloadConfig();
                                    Utils.sendMessage(sender, "&6" + target2.getName() + "'s &eplayerwarp was put in ready to build state (Fixed if broken)!");
                                }
                                else {
                                    Utils.sendMessage(sender, "&6" + target2.getName() + " &edoesn't have a playerwarp.");
                                }
                            }
                        }
                    }
                    else if (args[0].equalsIgnoreCase("warpqueue")) {
                        if (!sender.hasPermission("core.warpcreates.warpqueue")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                        }
                        else if (args.length == 2) {
                            final ArrayList<String> warpqueue = new ArrayList<String>();
                            if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") == null) {
                                Utils.sendMessage(sender, "&eThere are no &6warps &ein queue for &6approval&e.");
                                return false;
                            }
                            int count = 0;
                            final Set<String> set = (Set<String>)PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
                            final Iterator<String> it = set.iterator();
                            while (it.hasNext()) {
                                final UUID uuid = UUID.fromString(it.next());
                                final OfflinePlayer target3 = Bukkit.getOfflinePlayer(uuid);
                                final Player player2 = (Player)sender;
                                if ((target3.hasPlayedBefore() || target3 != null) && PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + uuid.toString()) != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target3.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("false")) {
                                    if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval").equalsIgnoreCase("true")) {
                                        warpqueue.add(target3.getName());
                                    }
                                    else {
                                        ++count;
                                    }
                                }
                            }
                            if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false).size() == count) {
                                Utils.sendMessage(sender, "&eThere are no &6warps &ein queue for &6approval&e.");
                                return false;
                            }
                            final Pattern pattern2 = Pattern.compile("[^0-9 ]");
                            final Matcher match2 = pattern2.matcher(args[1]);
                            final boolean found2 = match2.find();
                            if (found2) {
                                Utils.sendMessage(sender, "&cPlease enter a page number.");
                            }
                            else {
                                Utils.sendMessage(sender, "&eShowing all results for &3PlayerWarps &eneeding approval: ");
                                Utils.paginate(sender, warpqueue, Integer.parseInt(args[1]));
                            }
                        }
                        else {
                            Utils.sendMessage(sender, "&cPlease enter a page number.");
                        }
                    }
                    else if (args[0].equalsIgnoreCase("approve")) {
                        if (!sender.hasPermission("core.warpcreates.approve")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                        }
                        else {
                            final OfflinePlayer target4 = Bukkit.getOfflinePlayer(args[1]);
                            final Player player = (Player)sender;
                            if (target4.hasPlayedBefore() || target4 != null) {
                                if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + target4.getUniqueId().toString()) != null) {
                                    if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target4.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target4.getUniqueId().toString() + ".Building").equalsIgnoreCase("false")) {
                                        if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target4.getUniqueId().toString() + ".Approved") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target4.getUniqueId().toString() + ".Approved").equalsIgnoreCase("false")) {
                                            PlayerWarps.getWorldSetup();
                                            WorldListener.approveVoidWorld(player, target4);
                                            PlayerWarps.get().reloadConfig();
                                        }
                                        else {
                                            Utils.sendMessage(sender, "&6" + target4.getName() + "'s &eplayerwarp is already approved.");
                                        }
                                    }
                                    else {
                                        Utils.sendMessage(sender, "&6" + target4.getName() + "'s &eplayerwarp cannot be approved while they are building.");
                                    }
                                }
                                else {
                                    Utils.sendMessage(sender, "&6" + target4.getName() + " &edoesn't have a playerwarp.");
                                }
                            }
                        }
                    }
                    else if (args[0].equalsIgnoreCase("approveconfirm")) {
                        if (!sender.hasPermission("core.warpcreates.approve")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                        }
                        else {
                            final OfflinePlayer target4 = Bukkit.getOfflinePlayer(args[1]);
                            if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + target4.getUniqueId().toString()) != null) {
                                if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target4.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target4.getUniqueId().toString() + ".Building").equalsIgnoreCase("false")) {
                                    if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target4.getUniqueId().toString() + ".Approved") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target4.getUniqueId().toString() + ".Approved").equalsIgnoreCase("false")) {
                                        if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target4.getUniqueId().toString() + ".Need-Approval") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target4.getUniqueId().toString() + ".Need-Approval").equalsIgnoreCase("true")) {
                                            PlayerWarps.getWorldSetup();
                                            if (WorldListener.ready.containsKey(target4)) {
                                                PlayerWarps.getWorldSetup();
                                                WorldListener.approveConfirmVoidWorld(target4, false);
                                                Utils.sendMessage(sender, "&eYou have confirmed approval of &6" + target4.getName() + "'s &eplayerwarp!");
                                            }
                                            else {
                                                Utils.sendMessage(sender, "&eYou cannot confirm approval for &6" + target4.getName() + "'s &eplayerwarp as no one has looked at it:");
                                                Utils.sendMessage(sender, "&f/&ewarpcreate approve &6" + target4.getName());
                                            }
                                            PlayerWarps.get().reloadConfig();
                                        }
                                        else {
                                            Utils.sendMessage(sender, "&6" + target4.getName() + "'s &eplayerwarp is not ready yet.");
                                        }
                                    }
                                    else {
                                        Utils.sendMessage(sender, "&6" + target4.getName() + "'s &eplayerwarp is already approved.");
                                    }
                                }
                                else {
                                    Utils.sendMessage(sender, "&6" + target4.getName() + "'s &eplayerwarp cannot be approved while they are building.");
                                }
                            }
                            else {
                                Utils.sendMessage(sender, "&6" + target4.getName() + " &edoesn't have a playerwarp.");
                            }
                        }
                    }
                    else {
                        this.helpMenu(sender);
                    }
                }
                else if (args.length >= 1) {
                    if (args[0].equals("commandAdd")) {
                        if (!sender.hasPermission("core.warpcreates.commandAdd")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                        }
                        else if (args.length >= 1) {
                            if (sender instanceof Player) {
                                String command = "";
                                for (int i = 1; i < args.length; ++i) {
                                    final String arg = args[i] + " ";
                                    command += arg;
                                }
                                final Player p = (Player)sender;
                                if (PlayerWarps.get().getCustomData().getStringList("command-whitelist").contains(StringUtils.chop(command))) {
                                    p.sendMessage(Utils.replace("&6" + command + "&eis already whitelisted"));
                                }
                                else {
                                    final List<String> commands = (List<String>)PlayerWarps.get().getCustomData().getStringList("command-whitelist");
                                    commands.add(StringUtils.chop(command));
                                    PlayerWarps.get().getCustomData().set("command-whitelist", (Object)commands);
                                    PlayerWarps.get().saveConfig();
                                    PlayerWarps.get().reloadConfig();
                                    p.sendMessage(Utils.replace("&6" + command + "&ehas been added to the command whitelist"));
                                }
                            }
                            else {
                                sender.sendMessage(Utils.replace("&eOnly players can execute that command"));
                            }
                        }
                        else {
                            sender.sendMessage(Utils.replace("&ePlease specify a command to whitelist"));
                        }
                    }
                    else if (args[0].equals("commandDel")) {
                        if (!sender.hasPermission("core.warpcreates.commandDel")) {
                            Utils.sendMessage(sender, Commands.noPerms);
                        }
                        else if (args.length >= 1) {
                            if (sender instanceof Player) {
                                String command = "";
                                for (int i = 1; i < args.length; ++i) {
                                    final String arg = args[i] + " ";
                                    command += arg.toLowerCase();
                                }
                                final Player p = (Player)sender;
                                if (!PlayerWarps.get().getCustomData().getStringList("command-whitelist").contains(StringUtils.chop(command))) {
                                    p.sendMessage(Utils.replace("&6" + command + "&ewasn't already whitelisted"));
                                }
                                else {
                                    final List<String> commands = (List<String>)PlayerWarps.get().getCustomData().getStringList("command-whitelist");
                                    commands.remove(StringUtils.chop(command));
                                    PlayerWarps.get().getCustomData().set("command-whitelist", (Object)commands);
                                    PlayerWarps.get().saveConfig();
                                    PlayerWarps.get().reloadConfig();
                                    p.sendMessage(Utils.replace("&6" + command + "&ehas been removed from the command whitelist"));
                                }
                            }
                            else {
                                sender.sendMessage(Utils.replace("&eOnly players can execute that command"));
                            }
                        }
                        else {
                            sender.sendMessage(Utils.replace("&ePlease specify a command to unwhitelist"));
                        }
                    }
                    else {
                        this.helpMenu(sender);
                    }
                }
            }
        }
        else if (cmd.getName().equalsIgnoreCase("warpcreateblock")) {
            if (!sender.hasPermission("core.warpcreates.giveblock")) {
                Utils.sendMessage(sender, Commands.noPerms);
            }
            else if (sender instanceof ConsoleCommandSender) {
                if (args.length == 0) {
                    this.helpMenu2Console();
                }
                else if (args.length == 4) {
                    if (args[0].equalsIgnoreCase("giveBlock")) {
                        if (args[1] != null) {
                            if (args[2].equalsIgnoreCase("h") || args[2].equalsIgnoreCase("m") || args[2].equalsIgnoreCase("s")) {
                                final Player target = Bukkit.getPlayer(args[3].toString());
                                if (target != null) {
                                    if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
                                        Utils.sendConsoleMessage("&6" + target.getName() + " &ccannot be given this item as they're building a warp already.");
                                    }
                                    else {
                                        final Pattern pattern3 = Pattern.compile("[^0-9 ]");
                                        final Matcher match3 = pattern3.matcher(args[1]);
                                        final boolean found3 = match3.find();
                                        if (found3) {
                                            Utils.sendMessage(sender, "&cError: the time is not alphabetic nor symbolized.");
                                            return false;
                                        }
                                        int time3 = 0;
                                        final String timelength = "" + args[1] + "" + args[2];
                                        if (args[2].equalsIgnoreCase("h")) {
                                            time3 = Integer.parseInt(args[1]) * 3600;
                                        }
                                        else if (args[2].equalsIgnoreCase("m")) {
                                            time3 = Integer.parseInt(args[1]) * 60;
                                        }
                                        else if (args[1].equalsIgnoreCase("s")) {
                                            time3 = Integer.parseInt(args[1]);
                                        }
                                        final List<String> wclore = new ArrayList<String>();
                                        ItemStack wcblock = new ItemStack(Material.LAPIS_BLOCK);
                                        final ItemMeta im = wcblock.getItemMeta();
                                        wclore.add(Utils.replace("&3This is a WarpCreate."));
                                        wclore.add(Utils.replace("&3WarpCreates allow the player with"));
                                        wclore.add(Utils.replace("&3this item to create a PlayerWarp."));
                                        wclore.add(Utils.replace("&3This will clear your inventory so put away any other items."));
                                        wclore.add(Utils.replace("&7[&eRight-Click this to create a " + timelength + " WarpCreate&7]"));
                                        im.setDisplayName(Utils.replace("&3WarpCreate &7[&3" + timelength + "&7]"));
                                        im.setLore((List)wclore);
                                        wcblock.setItemMeta(im);
                                        final String antiDupe = RandomStringGenerator.randomString(35, true, true, false);
                                        wcblock = ItemMetadata.setMetadata(wcblock, "AntiDupe", antiDupe);
                                        target.getInventory().addItem(new ItemStack[] { ItemMetadata.setMetadata(wcblock, "WarpCreate", timelength) });
                                        Utils.sendConsoleMessage("&eYou have given a &3" + timelength + " &eWarpCreate &eto &6" + target.getName() + " &e.");
                                        Utils.sendMessage((CommandSender)target, "&eYou have been given a &3" + timelength + " &eWarpCreate &eto &6" + target.getName() + " &e.");
                                    }
                                }
                                else {
                                    Utils.sendMessage(sender, "&6" + args[3].toString() + " &eis not online.");
                                }
                            }
                            else {
                                Utils.sendMessage(sender, "&cYou can only use 1 time span in warpcreation.");
                            }
                        }
                        else {
                            this.helpMenu2Console();
                        }
                    }
                    else {
                        this.helpMenu2Console();
                    }
                }
                else {
                    this.helpMenu2Console();
                }
            }
            else if (sender instanceof Player) {
                if (args.length == 0) {
                    this.helpMenu2(sender);
                }
                else if (args.length == 4) {
                    if (args[0].equalsIgnoreCase("giveBlock")) {
                        if (args[1] != null) {
                            if (args[2].equalsIgnoreCase("h") || args[2].equalsIgnoreCase("m") || args[2].equalsIgnoreCase("s")) {
                                final Player target = Bukkit.getPlayer(args[3].toString());
                                final Player player = (Player)sender;
                                if (target != null) {
                                    if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + target.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
                                        Utils.sendMessage(sender, "&6" + target.getName() + "&ccannot be given this item as they're building a warp already.");
                                    }
                                    else {
                                        final Pattern pattern = Pattern.compile("[^0-9 ]");
                                        final Matcher match = pattern.matcher(args[1]);
                                        final boolean found = match.find();
                                        if (found) {
                                            Utils.sendMessage(sender, "&cError: the time is not alphabetic nor symbolized.");
                                            return false;
                                        }
                                        int time = 0;
                                        final String timelength2 = "" + args[1] + "" + args[2];
                                        if (args[2].equalsIgnoreCase("h")) {
                                            time = Integer.parseInt(args[1]) * 3600;
                                        }
                                        else if (args[2].equalsIgnoreCase("m")) {
                                            time = Integer.parseInt(args[1]) * 60;
                                        }
                                        else if (args[1].equalsIgnoreCase("s")) {
                                            time = Integer.parseInt(args[1]);
                                        }
                                        final List<String> wclore2 = new ArrayList<String>();
                                        ItemStack wcblock2 = new ItemStack(Material.LAPIS_BLOCK);
                                        final ItemMeta im2 = wcblock2.getItemMeta();
                                        im2.setDisplayName(Utils.replace("&3WarpCreate &7[&3" + timelength2 + "&7]"));
                                        wclore2.add(Utils.replace("&3This is a WarpCreate."));
                                        wclore2.add(Utils.replace("&3WarpCreates allow the player with"));
                                        wclore2.add(Utils.replace("&3this item to create a PlayerWarp."));
                                        wclore2.add(Utils.replace("&3This will clear your inventory so put away any other items."));
                                        wclore2.add(Utils.replace("&7[&eRight-Click this to create a " + timelength2 + " WarpCreate&7]"));
                                        im2.setLore((List)wclore2);
                                        wcblock2.setItemMeta(im2);
                                        final String antiDupe2 = RandomStringGenerator.randomString(35, true, true, false);
                                        wcblock2 = ItemMetadata.setMetadata(wcblock2, "AntiDupe", antiDupe2);
                                        target.getInventory().addItem(new ItemStack[] { ItemMetadata.setMetadata(wcblock2, "WarpCreate", timelength2) });
                                        Utils.sendMessage(sender, "&eYou have given a &3" + timelength2 + " &eWarpCreate &eto &6" + target.getName() + " &e.");
                                        Utils.sendMessage((CommandSender)target, "&eYou have been given a &3" + timelength2 + " &eWarpCreate &eto &6" + target.getName() + " &e.");
                                    }
                                }
                                else {
                                    Utils.sendMessage(sender, "&6" + args[3].toString() + " &eis not online.");
                                }
                            }
                            else {
                                Utils.sendMessage(sender, "&cYou can only use 1 time span in warpcreation.");
                            }
                        }
                        else {
                            this.helpMenu2(sender);
                        }
                    }
                    else {
                        this.helpMenu2(sender);
                    }
                }
                else {
                    this.helpMenu2(sender);
                }
            }
        }
        return true;
    }

    private void helpMenu(final CommandSender player) {
        final List<String> helpMenu = new ArrayList<String>();
        int count = 0;
        helpMenu.add(Utils.replace(this.help));
        if (player.hasPermission("core.warpcreates.create")) {
            helpMenu.add(Utils.replace(" &e- /warpcreate create <time> <time-span> <player-name> &e- &3Example: &e/warpcreate create 10 m StarZorrow"));
            ++count;
        }
        if (player.hasPermission("core.warpcreates.delete")) {
            helpMenu.add(Utils.replace(" &e- /warpcreate delete <player-name> &e- &3Example: &e/warpcreate delete StarZorrow"));
            ++count;
        }
        if (player.hasPermission("core.warpcreates.fix")) {
            helpMenu.add(Utils.replace(" &e- /warpcreate fix <player-name> &e- &3Example: &e/warpcreate fix StarZorrow"));
            ++count;
        }
        if (player.hasPermission("core.warpcreates.warpqueue")) {
            helpMenu.add(Utils.replace(" &e- /warpcreate warpqueue <page> &e- &3Example: &e/warpcreate warpqueue 4"));
            ++count;
        }
        if (player.hasPermission("core.warpcreates.approve")) {
            helpMenu.add(Utils.replace(" &e- /warpcreate approve <player-name> &e- &3Example: &e/warpcreate approve StarZorrow"));
            ++count;
        }
        if (player.hasPermission("core.warpcreates.approveconfirm")) {
            helpMenu.add(Utils.replace(" &e- /warpcreate approveconfirm <player-name> &e- &3Example: &e/warpcreate approveconfirm StarZorrow"));
            ++count;
        }
        if (player.hasPermission("core.warpcreates.commandAdd")) {
            helpMenu.add(Utils.replace(" &e- /warpcreate commandAdd <command> &e- &3Example: &e/warpcreate commandAdd kit tools"));
            ++count;
        }
        if (player.hasPermission("core.warpcreates.commandDel")) {
            helpMenu.add(Utils.replace(" &e- /warpcreate commandDel <command> &e- &3Example: &e/warpcreate commandDel kit tools"));
            ++count;
        }
        helpMenu.add(Utils.replace("&e- Showing page &61 &eof &61 &e(" + count + " results)."));
        for (final String s : helpMenu) {
            Utils.sendMessage(player, s);
        }
    }

    private void helpMenuConsole() {
        final List<String> helpMenu = new ArrayList<String>();
        int count = 0;
        helpMenu.add(Utils.replace(this.help));
        helpMenu.add(Utils.replace(" &e- warpcreate create <time> <time-span> <player-name> &e- &3Example: &ewarpcreate create 10 m StarZorrow"));
        ++count;
        helpMenu.add(Utils.replace(" &e- warpcreate delete <player-name> &e- &3Example: &ewarpcreate delete StarZorrow"));
        ++count;
        helpMenu.add(Utils.replace(" &e- warpcreate fix <player-name> &e- &3Example: &ewarpcreate fix StarZorrow"));
        ++count;
        helpMenu.add(Utils.replace(" &e- warpcreate warpqueue <page> &e- &3Example: &ewarpcreate warpqueue 4"));
        ++count;
        helpMenu.add(Utils.replace(" &e- warpcreate approve <player-name> &e- &3Example: &ewarpcreate approve StarZorrow"));
        ++count;
        helpMenu.add(Utils.replace(" &e- warpcreate approveconfirm <player-name> &e- &3Example: &ewarpcreate approveconfirm StarZorrow"));
        ++count;
        helpMenu.add(Utils.replace(" &e- warpcreate commandAdd <command> &e- &3Example: &ewarpcreate commandAdd kit tools"));
        ++count;
        helpMenu.add(Utils.replace(" &e- warpcreate commandDel <command> &e- &3Example: &ewarpcreate commandDel kit tools"));
        ++count;
        helpMenu.add(Utils.replace("&e- Showing page &61 &eof &61 &e(" + count + " results)."));
        for (final String s : helpMenu) {
            Utils.sendConsoleMessage(s);
        }
    }

    private void helpMenu2(final CommandSender player) {
        final List<String> helpMenu = new ArrayList<String>();
        int count = 0;
        helpMenu.add(Utils.replace(this.help));
        if (player.hasPermission("core.warpcreates.giveblock")) {
            helpMenu.add(Utils.replace(" &e- /warpcreateblock giveBlock <time-span> <player-name> &e- &3Example: &e/warpcreateblock giveBlock 10 m StarZorrow"));
            ++count;
        }
        helpMenu.add(Utils.replace("&e- Showing page &61 &eof &61 &e(" + count + " results)."));
        for (final String s : helpMenu) {
            Utils.sendMessage(player, s);
        }
    }

    private void helpMenu2Console() {
        final List<String> helpMenu = new ArrayList<String>();
        int count = 0;
        helpMenu.add(Utils.replace(this.help));
        helpMenu.add(Utils.replace(" &e- warpcreateblock giveBlock <time-span> <player-name> &e- &3Example: &ewarpcreateblock giveBlock 10 m StarZorrow"));
        ++count;
        helpMenu.add(Utils.replace("&e- Showing page &61 &eof &61 &e(" + count + " results)."));
        for (final String s : helpMenu) {
            Utils.sendConsoleMessage(s);
        }
    }

    static {
        Commands.warpqueue = new ArrayList<String>();
        Commands.noPerms = "&cYou do not have permission to use this!";
    }
}
