package str.playerwarps.commands.gui;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import java.util.UUID;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.OfflinePlayer;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.command.ConsoleCommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.inventory.meta.SkullMeta;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitScheduler;
import org.bukkit.scheduler.BukkitTask;

import com.google.common.collect.Multiset.Entry;

import net.md_5.bungee.api.ChatColor;
import str.playerwarps.PlayerWarps;
import str.playerwarps.gui.ItemBuilder;
import str.playerwarps.gui.buttons.GUIButton;
import str.playerwarps.gui.types.PaginatedGUI;
import str.playerwarps.util.Utils;
import str.playerwarps.util.Zone;

public class GUI implements CommandExecutor, Listener {
	
	public static BukkitTask timer;
	public static HashMap<String, Boolean> check = new HashMap<String, Boolean>();
	public static ArrayList<String> order = new ArrayList<String>();
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label, String[] args) {
		if (cmd.getName().equalsIgnoreCase("pw")) {
				if (sender instanceof ConsoleCommandSender) {
					Utils.sendConsoleMessage("&cYou cannot use this command in console.");
				}
				else {
				if (args.length > 0) {
					if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") == null || Bukkit.getWorld("PlayerWarps-World") == null) {
						Utils.sendMessage(sender, "&eNo &6playerwarps &efound.");
						return true;
					}
					if (args.length == 1) {
						if (args[0].equalsIgnoreCase("page")) {
							Utils.sendMessage(sender, "&cPlease enter a page number.");
							return false;
						}
						OfflinePlayer warpto = (OfflinePlayer) Bukkit.getOfflinePlayer(args[0]);
						if (warpto == null || !PlayerWarps.get().getCustomData().contains("Warps-Created-By." + warpto.getUniqueId().toString())) {
							Utils.sendMessage(sender, "&6" + args[0] + " &edoesn't exist!");
							Utils.sendMessage(sender, "&eUsage: &f/&eplayerwarp &e(player).");
							return false;
						}
						else {
							if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + warpto.getUniqueId().toString()) != null) {
								if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + warpto.getUniqueId().toString() + ".Need-Approval") == null) {
									Utils.sendMessage(sender, "&6" + args[0] + " &edoesn't exist!");
									Utils.sendMessage(sender, "&eUsage: &f/&eplayerwarp &e(player).");
									return false;
								}
								else if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + warpto.getUniqueId().toString() + ".Need-Approval").equalsIgnoreCase("true")) {
									if (warpto.getName() == sender.getName()) {
										Player player = (Player) sender;
										Location loc = Utils.getPlayerWarpLocation(player.getUniqueId().toString());
										Utils.sendMessage(sender, "&eTeleporting to &6" + sender.getName() + "'s &eplayerwarp.");
										player.teleport(loc);
										return false;
									}
									Utils.sendMessage(sender, "&cYou cannot warp to this playerwarp while it's not approved!");
									return false;
								}
								else {
									Player player = (Player) sender;
									Utils.teleportToWarp(player, warpto.getUniqueId().toString());
								}
							}
						}
					}
					else if (args.length >= 2) {
						if (args.length > 2) {
							Utils.sendMessage(sender, "&cPlease enter a page number.");
						}
						else if (args.length == 2) {
							Pattern pattern = Pattern.compile("[^0-9 ]");
							Matcher match = pattern.matcher(args[1]);
							boolean found = match.find();
	
							if (found) {
								Utils.sendMessage(sender, "&cPlease enter a page number.");
							}
							else {
								int page = Integer.parseInt(args[1]);
								PaginatedGUI menu = new PaginatedGUI("PlayerWarps");
								
								if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") == null || Bukkit.getWorld("PlayerWarps-World") == null) {
									Utils.sendMessage(sender, "&eNo &6playerwarps &efound.");
									return true;
								}
								GUIButton button4 = new GUIButton(ItemBuilder.start(Material.SKULL_ITEM).data((short)3).build());
								Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
								for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
									UUID uuid = UUID.fromString(it.next());
									if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + Bukkit.getOfflinePlayer(uuid).getUniqueId().toString()) != null) {
										if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString()) == null) {
											if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") == null) {
												if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
													if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("true")) {
														if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") == null) {
															continue;
														}
													}
												}
												else {
													continue;
												}
											}
										}
										else {
											if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") == null) {
												if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
													if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("true")) {
														if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") == null) {
															continue;
														}
													}
												}
												else {
													continue;
												}
											}
											// Start glass bar, own playerwarp and random playerwarp.
											
											GUIButton button2 = new GUIButton(ItemBuilder.start(Material.STAINED_GLASS_PANE).data((short)7).name(" ").build());
											button2.setListener(event -> {
												event.setCancelled(true);
											});
											for (int i = 0; i < 3; i++) {
												menu.setButton(i, button2);
											}
											
											List<String> lore2 = new ArrayList<String>();
											if (Utils.getWarps() < 4) {
												lore2.add(Utils.replace("&c5 playerwarps must be approved to use this."));
											}
											else {
												lore2.add("");
												lore2.add(Utils.replace("&7Players&7: &3&k12345"));
												lore2.add("");
												lore2.add(Utils.replace("&a[Click to teleport]"));
											}
//											if (Utils.getWarps() >= 1) {
											GUIButton button3 = new GUIButton(ItemBuilder.start(Material.SKULL_ITEM).data((short)3).lore(lore2).build());
											button3.setListener(event -> {
												event.setCancelled(true);
												if (event.getRawSlot() < event.getInventory().getSize()) {
													if (Utils.getWarps() > 4) {
														Player player = (Player) event.getWhoClicked();
														ArrayList<String> random = new ArrayList<>();
														for (String r : set) {
															random.add(r);
														}
														String uuidd = random.get(getRandomInt(0, random.size()));
														if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuidd.toString() + ".Need-Approval") != null) {
															if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuidd.toString() + ".Building") != null) {
																if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuidd.toString() + ".Building").equalsIgnoreCase("false")) {
																	if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuidd.toString() + ".worldname") != null) {
																		UUID uuid1 = uuid.fromString(uuidd);
																		if (Bukkit.getPlayer(uuid1) != null) {
																			Player warpto2 = (Player) Bukkit.getPlayer(uuid1);
																			Utils.teleportToWarp(player, warpto2.getUniqueId().toString());
																			player.closeInventory();
																		}
																		else {
																			OfflinePlayer warpto2 = (OfflinePlayer) Bukkit.getOfflinePlayer(uuid1);
																			Utils.teleportToWarp(player, warpto2.getUniqueId().toString());
																			player.closeInventory();
																		}
																	}
																}
															}
														}
													}
												}
											});
											SkullMeta sm2 = (SkullMeta) button3.getItem().getItemMeta();
											sm2.setDisplayName(Utils.replace1("&6&lRandom Warp"));
											button3.getItem().setItemMeta(sm2);
											menu.setButton(3, button3);
											
											menu.setButton(4, button2);
											
									        List<String> ownWarpLore = new ArrayList<String>();
									        Player player1 = (Player) sender;
											if (player1 == null || !PlayerWarps.get().getCustomData().contains("Warps-Created-By." + player1.getUniqueId().toString())) {
												ownWarpLore.add("&7You do not own a Player Warp");
											}
											else {
												if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + player1.getUniqueId().toString()) != null) {
													if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player1.getUniqueId().toString() + ".Need-Approval") != null) {
														if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player1.getUniqueId().toString() + ".Need-Approval").equalsIgnoreCase("false")) {
															ownWarpLore.add("&aYour warp is approved!");
															int sort = 0;
															Location loc = Utils.getPlayerWarpLocation(player1.getUniqueId().toString());
															for (Player players : Bukkit.getWorld("PlayerWarps-World").getPlayers()) {
																if (Zone.contains(players.getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
																	sort++;
																}
															}
															ownWarpLore.add(Utils.replace("&7Players&7: &3" + sort));
															ownWarpLore.add("");
														}
														else {
															ownWarpLore.add("&cYour warp is not approved!");
															ownWarpLore.add("");
														}
													}
												}
												ownWarpLore.add("&a[Click to teleport]");
											}
											GUIButton ownWarp = new GUIButton(ItemBuilder.start(Material.BED).name(PaginatedGUI.OWN_WARP).lore(ownWarpLore).build());
									        ownWarp.setListener(event -> {
									        	event.setCancelled(true);
									        	if (event.getRawSlot() < event.getInventory().getSize()) {
										        	Player player = (Player) event.getWhoClicked();
										        	if (player == null || !PlayerWarps.get().getCustomData().contains("Warps-Created-By." + player.getUniqueId().toString())) {
										        		return;
													}
										        	else {
														if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + player.getUniqueId().toString()) != null) {
															if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString() + ".Need-Approval") != null) {
																if (player.getOpenInventory() != null) player.closeInventory();
																Location loc = Utils.getPlayerWarpLocation(player.getUniqueId().toString());
																Utils.sendMessage(player, "&eTeleporting to &6" + player.getName() + "'s &eplayerwarp.");
																player.teleport(loc);
															}
														}
										        	}
									        	}
									        });
									        menu.setButton(5, ownWarp);
										        
											for (int i = 6; i < 9; i++) {
												menu.setButton(i, button2);
											}
											
											// End of glass bar, own playerwarp and random playerwarp.
											
											if (Utils.getWarps() >= 1) {
												if (Bukkit.getPlayer(uuid) != null) {
													List<String> lore = new ArrayList<String>();
													lore.add("");
													int sort = 0;
													Location loc = Utils.getPlayerWarpLocation(Bukkit.getOfflinePlayer(uuid).getUniqueId().toString());
													for (Player players : Bukkit.getWorld("PlayerWarps-World").getPlayers()) {
														if (Zone.contains(players.getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
															sort++;
														}
													}
													lore.add(Utils.replace("&7Players&7: &3" + sort));
													lore.add("");
													lore.add(Utils.replace("&a[Click to teleport]"));
													GUIButton button = new GUIButton(ItemBuilder.start(Material.SKULL_ITEM).data((short)3).name(Bukkit.getPlayer(uuid).getName()).lore(lore).build());
													String warp = button.getItem().getItemMeta().getDisplayName().replace(Utils.replace1("&6&l"), "");
													Player warpto = (Player) Bukkit.getPlayer(warp);
													button.setListener(event -> {
														event.setCancelled(true);
														if (event.getRawSlot() < event.getInventory().getSize()) {
															Player player = (Player) event.getWhoClicked();
															if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") != null) {
																if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
																	if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("false")) {
																		if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") != null) {
																			Utils.teleportToWarp(player, warpto.getUniqueId().toString());
																			player.closeInventory();
																		}
																	}
																	else {
																		Utils.sendMessage(sender, "&eYou cannot warp to &6" + warpto.getName() + "'s &eplayerwarp while they are building.");
																	}
																}
															}
														}
													});
													SkullMeta sm1 = (SkullMeta) button.getItem().getItemMeta();
													sm1.setOwner(Bukkit.getPlayer(button.getItem().getItemMeta().getDisplayName()).getName());
													sm1.setDisplayName(Utils.replace1("&6&l" + Bukkit.getPlayer(uuid).getName()));
													button.getItem().setItemMeta(sm1);
													
													if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") != null) {
														if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
															if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("false")) {
																if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") != null) {
																	for (int i = 0; i < PlayerWarps.get().warpsort.size(); i++) {
																		String s1 = PlayerWarps.get().warpsort.get(i);
																		String s2 = s1.substring(s1.indexOf("-") + 2);
																		int sort1 = PlayerWarps.get().warpsort.lastIndexOf(s1) + 9;
																		if (s2.trim().equals(uuid.toString())) {
																			menu.setButton(sort1, button);
																		}
																	}
																	
																	
																	
																}
																else if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("true")) {
																	continue;
																}
															}
														}
														else {
															continue;
														}
													}
												}
												else {
													List<String> lore = new ArrayList<String>();
													lore.add("");
													int sort = 0;
													Location loc = Utils.getPlayerWarpLocation(Bukkit.getOfflinePlayer(uuid).getUniqueId().toString());
													for (Player players : Bukkit.getWorld("PlayerWarps-World").getPlayers()) {
														if (Zone.contains(players.getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
															sort++;
														}
													}
													lore.add(Utils.replace1("&7Players&7: &3" + sort));
													lore.add("");
													lore.add(Utils.replace1("&a[Click to teleport]"));
													if (!Bukkit.getOfflinePlayer(uuid).hasPlayedBefore() || Bukkit.getOfflinePlayer(uuid) == null) {
														continue;
													}
													else {
														GUIButton button = new GUIButton(ItemBuilder.start(Material.SKULL_ITEM).data((short)3).name(Bukkit.getOfflinePlayer(uuid).getName()).lore(lore).build());
														String warp = button.getItem().getItemMeta().getDisplayName().replace(Utils.replace1("&6&l"), "");
														OfflinePlayer warpto = (OfflinePlayer) Bukkit.getOfflinePlayer(warp);
														
														
														button.setListener(event -> {
															event.setCancelled(true);
															if (event.getRawSlot() < event.getInventory().getSize()) {
																Player player = (Player) event.getWhoClicked();
																if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") != null) {
																	if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
																		if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("false")) {
																			if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") != null) {
																				Utils.teleportToWarp(player, warpto.getUniqueId().toString());
																				player.closeInventory();
																			}
																		}
																		else {
																			Utils.sendMessage(sender, "&eYou cannot warp to &6" + warpto.getName() + "'s &eplayerwarp while they are building.");
																		}
																	}
																}
															}
														});
														
														
														SkullMeta sm1 = (SkullMeta) button.getItem().getItemMeta();
														sm1.setOwner(Bukkit.getOfflinePlayer(button.getItem().getItemMeta().getDisplayName()).getName());
														sm1.setDisplayName(Utils.replace1("&6&l" + Bukkit.getOfflinePlayer(uuid).getName()));
														button.getItem().setItemMeta(sm1);
														if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") != null) {
															if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
																if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("false")) {
																	if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") != null) {
																		for (int i = 0; i < PlayerWarps.get().warpsort.size(); i++) {
																			String s1 = PlayerWarps.get().warpsort.get(i);
																			String s2 = s1.substring(s1.indexOf("-") + 2);
																			int sort1 = PlayerWarps.get().warpsort.lastIndexOf(s1) + 9;
																			if (s2.trim().equals(uuid.toString())) {
																				menu.setButton(sort1, button);
																			}
																		}
																		
																	}
																	else if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("true")) {
																		continue;
																	}
																}
															}
															else {
																continue;
															}
														}
													}
												}
											}
//											else {
//												Utils.sendMessage(sender, "&eNo approved &6playerwarps &efound.");
//												return true;
//											}
										}
								    }
								}
//								if (Utils.getWarps() == 0) {
//									Utils.sendMessage(sender, "&eNo approved &6playerwarps &efound.");
//									return true;
//								}
								
								Player player1 = (Player) sender;
								if (((menu.getMaxPage() + 1) < page) || page == 0) {
									Utils.sendMessage(player1, "&cInvalid Page number. Pages: " + (menu.getCurrentPage() + 1) + " - " + (menu.getFinalPage() + 1));
									return false;
								}
								menu.setCurrentPage(page - 1);
								menu.setDisplayName("Player Warps &7(&6" + (menu.getCurrentPage() + 1) + "/" + (menu.getFinalPage() + 1) + "&7)" );
								player1.openInventory(menu.getInventory());
								menu.getInventory().setMaxStackSize(500);
							}
						}
					}
				}
				else if (args.length == 0) {
					PaginatedGUI menu = new PaginatedGUI("PlayerWarps");
					
					if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") == null || Bukkit.getWorld("PlayerWarps-World") == null) {
						Utils.sendMessage(sender, "&eNo &6playerwarps &efound.");
						return true;
					}
					GUIButton button4 = new GUIButton(ItemBuilder.start(Material.SKULL_ITEM).data((short)3).build());
					Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
					for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
						UUID uuid = UUID.fromString(it.next());
						if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + Bukkit.getOfflinePlayer(uuid).getUniqueId().toString()) != null) {
							if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString()) == null) {
								if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") == null) {
									if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
										if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("true")) {
											if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") == null) {
												continue;
											}
										}
									}
									else {
										continue;
									}
								}
							}
							else {
								if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") == null) {
									if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
										if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("true")) {
											if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") == null) {
												continue;
											}
										}
									}
									else {
										continue;
									}
								}
								// Start glass bar, own playerwarp and random playerwarp.
								
								GUIButton button2 = new GUIButton(ItemBuilder.start(Material.STAINED_GLASS_PANE).data((short)7).name(" ").build());
								button2.setListener(event -> {
									event.setCancelled(true);
								});
								for (int i = 0; i < 3; i++) {
									menu.setButton(i, button2);
								}
								
						        List<String> lore2 = new ArrayList<String>();
								if (Utils.getWarps() < 4) {
									lore2.add(Utils.replace("&c5 playerwarps must be approved to use this."));
								}
								else {
									lore2.add("");
									lore2.add(Utils.replace("&7Players&7: &3&k12345"));
									lore2.add("");
									lore2.add(Utils.replace("&a[Click to teleport]"));
								}
//								if (Utils.getWarps() >= 1) {
								GUIButton button3 = new GUIButton(ItemBuilder.start(Material.SKULL_ITEM).data((short)3).lore(lore2).build());
								button3.setListener(event -> {
									event.setCancelled(true);
									if (event.getRawSlot() < event.getInventory().getSize()) {
										if (Utils.getWarps() > 4) {
											Player player = (Player) event.getWhoClicked();
											ArrayList<String> random = new ArrayList<>();
											for (String r : set) {
												random.add(r);
											}
											String uuidd = random.get(getRandomInt(0, random.size()));
											if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuidd.toString() + ".Need-Approval") != null) {
												if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuidd.toString() + ".Building") != null) {
													if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuidd.toString() + ".Building").equalsIgnoreCase("false")) {
														if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuidd.toString() + ".worldname") != null) {
															UUID uuid1 = uuid.fromString(uuidd);
															if (Bukkit.getPlayer(uuid1) != null) {
																Player warpto2 = (Player) Bukkit.getPlayer(uuid1);
																Utils.teleportToWarp(player, warpto2.getUniqueId().toString());
																player.closeInventory();
															}
															else {
																OfflinePlayer warpto2 = (OfflinePlayer) Bukkit.getOfflinePlayer(uuid1);
																Utils.teleportToWarp(player, warpto2.getUniqueId().toString());
																player.closeInventory();
															}
														}
													}
												}
											}
										}
									}
								});
								SkullMeta sm2 = (SkullMeta) button3.getItem().getItemMeta();
								sm2.setDisplayName(Utils.replace1("&6&lRandom Warp"));
								button3.getItem().setItemMeta(sm2);
								menu.setButton(3, button3);
								
								menu.setButton(4, button2);
								
						        List<String> ownWarpLore = new ArrayList<String>();
						        Player player1 = (Player) sender;
								if (player1 == null || !PlayerWarps.get().getCustomData().contains("Warps-Created-By." + player1.getUniqueId().toString())) {
									ownWarpLore.add("&7You do not own a Player Warp");
								}
								else {
									if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + player1.getUniqueId().toString()) != null) {
										if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player1.getUniqueId().toString() + ".Need-Approval") != null) {
											if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player1.getUniqueId().toString() + ".Need-Approval").equalsIgnoreCase("false")) {
												ownWarpLore.add("&aYour warp is approved!");
												int sort = 0;
												Location loc = Utils.getPlayerWarpLocation(player1.getUniqueId().toString());
												for (Player players : Bukkit.getWorld("PlayerWarps-World").getPlayers()) {
													if (Zone.contains(players.getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
														sort++;
													}
												}
												ownWarpLore.add(Utils.replace("&7Players&7: &3" + sort));
												ownWarpLore.add("");
											}
											else {
												ownWarpLore.add("&cYour warp is not approved!");
												ownWarpLore.add("");
											}
										}
									}
									ownWarpLore.add("&a[Click to teleport]");
								}
								GUIButton ownWarp = new GUIButton(ItemBuilder.start(Material.BED).name(PaginatedGUI.OWN_WARP).lore(ownWarpLore).build());
						        ownWarp.setListener(event -> {
						        	event.setCancelled(true);
						        	if (event.getRawSlot() < event.getInventory().getSize()) {
						        		Player player = (Player) event.getWhoClicked();
						        		if (player == null || !PlayerWarps.get().getCustomData().contains("Warps-Created-By." + player.getUniqueId().toString())) {
						        			return;
						        		}
						        		else {
						        			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + player.getUniqueId().toString()) != null) {
						        				if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + player.getUniqueId().toString() + ".Need-Approval") != null) {
						        					if (player.getOpenInventory() != null) player.closeInventory();
						        					Location loc = Utils.getPlayerWarpLocation(player.getUniqueId().toString());
						        					Utils.sendMessage(player, "&eTeleporting to &6" + player.getName() + "'s &eplayerwarp.");
						        					player.teleport(loc);
						        				}
											}
										}
						        	}
						        });
						        menu.setButton(5, ownWarp);
						        
								for (int i = 6; i < 9; i++) {
									menu.setButton(i, button2);
								}
//								}
								
								// End of glass bar, own playerwarp and random playerwarp.
								
								if (Utils.getWarps() >= 1) {
									if (Bukkit.getPlayer(uuid) != null) {
										List<String> lore = new ArrayList<String>();
										lore.add("");
										int sort = 0;
										Location loc = Utils.getPlayerWarpLocation(Bukkit.getOfflinePlayer(uuid).getUniqueId().toString());
										for (Player players : Bukkit.getWorld("PlayerWarps-World").getPlayers()) {
											if (Zone.contains(players.getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
												sort++;
											}
										}
										lore.add(Utils.replace("&7Players&7: &3" + sort));
										lore.add("");
										lore.add(Utils.replace("&a[Click to teleport]"));
										GUIButton button = new GUIButton(ItemBuilder.start(Material.SKULL_ITEM).data((short)3).name(Bukkit.getPlayer(uuid).getName()).lore(lore).build());
										String warp = button.getItem().getItemMeta().getDisplayName().replace(Utils.replace1("&6&l"), "");
										Player warpto = (Player) Bukkit.getPlayer(warp);
										button.setListener(event -> {
											event.setCancelled(true);
											if (event.getRawSlot() < event.getInventory().getSize()) {
												Player player = (Player) event.getWhoClicked();
												if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") != null) {
													if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
														if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("false")) {
															if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") != null) {
																Utils.teleportToWarp(player, warpto.getUniqueId().toString());
																player.closeInventory();
															}
														}
														else {
															Utils.sendMessage(sender, "&eYou cannot warp to &6" + warpto.getName() + "'s &eplayerwarp while they are building.");
														}
													}
												}
											}
										});
										SkullMeta sm1 = (SkullMeta) button.getItem().getItemMeta();
										sm1.setOwner(Bukkit.getPlayer(button.getItem().getItemMeta().getDisplayName()).getName());
										sm1.setDisplayName(Utils.replace1("&6&l" + Bukkit.getPlayer(uuid).getName()));
										button.getItem().setItemMeta(sm1);
										
										if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") != null) {
											if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
												if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("false")) {
													if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") != null) {
														for (int i = 0; i < PlayerWarps.get().warpsort.size(); i++) {
															String s1 = PlayerWarps.get().warpsort.get(i);
															String s2 = s1.substring(s1.indexOf("-") + 2);
															int sort1 = PlayerWarps.get().warpsort.lastIndexOf(s1) + 9;
															if (s2.trim().equals(uuid.toString())) {
																menu.setButton(sort1, button);
															}
														}
														
														
														
													}
													else if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("true")) {
														continue;
													}
												}
											}
											else {
												continue;
											}
										}
									}
									else {
										List<String> lore = new ArrayList<String>();
										lore.add("");
										int sort = 0;
										Location loc = Utils.getPlayerWarpLocation(Bukkit.getOfflinePlayer(uuid).getUniqueId().toString());
										for (Player players : Bukkit.getWorld("PlayerWarps-World").getPlayers()) {
											if (Zone.contains(players.getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
												sort++;
											}
										}
										lore.add(Utils.replace1("&7Players&7: &3" + sort));
										lore.add("");
										lore.add(Utils.replace1("&a[Click to teleport]"));
										if (!Bukkit.getOfflinePlayer(uuid).hasPlayedBefore() || Bukkit.getOfflinePlayer(uuid) == null) {
											continue;
										}
										else {
											GUIButton button = new GUIButton(ItemBuilder.start(Material.SKULL_ITEM).data((short)3).name(Bukkit.getOfflinePlayer(uuid).getName()).lore(lore).build());
											String warp = button.getItem().getItemMeta().getDisplayName().replace(Utils.replace1("&6&l"), "");
											OfflinePlayer warpto = (OfflinePlayer) Bukkit.getOfflinePlayer(warp);
											
											
											button.setListener(event -> {
												event.setCancelled(true);
												if (event.getRawSlot() < event.getInventory().getSize()) {
													Player player = (Player) event.getWhoClicked();
													if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") != null) {
														if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
															if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("false")) {
																if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") != null) {
																	Utils.teleportToWarp(player, warpto.getUniqueId().toString());
																	player.closeInventory();
																}
															}
															else {
																Utils.sendMessage(sender, "&eYou cannot warp to &6" + warpto.getName() + "'s &eplayerwarp while they are building.");
															}
														}
													}
												}
											});
											
											
											SkullMeta sm1 = (SkullMeta) button.getItem().getItemMeta();
											sm1.setOwner(Bukkit.getOfflinePlayer(button.getItem().getItemMeta().getDisplayName()).getName());
											sm1.setDisplayName(Utils.replace1("&6&l" + Bukkit.getOfflinePlayer(uuid).getName()));
											button.getItem().setItemMeta(sm1);
											if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Need-Approval") != null) {
												if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building") != null) {
													if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("false")) {
														if (PlayerWarps.get().getCustomData().get("Warps-Created-By." + uuid.toString() + ".worldname") != null) {
															for (int i = 0; i < PlayerWarps.get().warpsort.size(); i++) {
																String s1 = PlayerWarps.get().warpsort.get(i);
																String s2 = s1.substring(s1.indexOf("-") + 2);
																int sort1 = PlayerWarps.get().warpsort.lastIndexOf(s1) + 9;
																if (s2.trim().equals(uuid.toString())) {
																	menu.setButton(sort1, button);
																}
															}
															
														}
														else if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".Building").equalsIgnoreCase("true")) {
															continue;
														}
													}
												}
												else {
													continue;
												}
											}
										}
									}
								}
//								else {
//									Utils.sendMessage(sender, "&eNo approved &6playerwarps &efound.");
//									return true;
//								}
							}
					    }
					}
//					if (Utils.getWarps() == 0) {
//						Utils.sendMessage(sender, "&eNo approved &6playerwarps &efound.");
//						return true;
//					}
					
					Player player1 = (Player) sender;
					menu.setDisplayName("Player Warps &7(&6" + (menu.getCurrentPage() + 1) + "/" + (menu.getFinalPage() + 1) + "&7)" );
					player1.openInventory(menu.getInventory());
					menu.getInventory().setMaxStackSize(500);
				}
			}
		}
		return true;
	}
	
	public static int getRandomInt(int min, int max) {
        Random random = new Random();
        int theMin = min;
        int theMax = max;
        int result = random.nextInt(theMax - theMin) + theMin;
        return result;
    }
	
    public void sortWarps() {
    	if (PlayerWarps.get().getCustomData().getStringList("Warps-Created-By") == null) {
    		return;
    	}
    	Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
        for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
			UUID uuid = UUID.fromString(it.next());
			int sort = Bukkit.getWorld("PlayerWarp " + uuid.toString()).getPlayers().size();
			PlayerWarps.get().warpsort.add(sort + " - " + uuid.toString());
		}
        Collections.sort(PlayerWarps.get().warpsort, Collections.reverseOrder());
		if (PlayerWarps.get().getCustomData().getStringList("WarpList") == null) {
			PlayerWarps.get().getCustomData().set("WarpSort", PlayerWarps.get().warpsort);
			PlayerWarps.get().saveConfig();
			PlayerWarps.get().reloadConfig();
		}
		else {
			PlayerWarps.get().getCustomData().set("WarpSort", null);
			PlayerWarps.get().getCustomData().set("WarpSort", PlayerWarps.get().warpsort);
			PlayerWarps.get().saveConfig();
			PlayerWarps.get().reloadConfig();
		}
    }
}
