package str.playerwarps.listener;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.UUID;

import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.inventory.InventoryAction;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCreativeEvent;
import org.bukkit.event.inventory.InventoryDragEvent;
import org.bukkit.event.inventory.InventoryInteractEvent;
import org.bukkit.event.inventory.InventoryMoveItemEvent;
import org.bukkit.event.inventory.InventoryPickupItemEvent;
import org.bukkit.event.player.PlayerDropItemEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerItemConsumeEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.event.player.PlayerPickupItemEvent;
import org.bukkit.inventory.ItemStack;

import str.playerwarps.PlayerWarps;
import str.playerwarps.util.Utils;

public class InventoryListener implements Listener {
	
//	static List<Material> filterList = new ArrayList<>();
	public List<String> filterList = PlayerWarps.get().getCustomData().getStringList("Blocked-Items");
	
	@EventHandler
	public void onInventory1(InventoryClickEvent event) {
		Player p = (Player) event.getWhoClicked();
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) != null) {
			if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
				for (int i = 0; i < filterList.size(); i++) {
					String blacklisted = filterList.get(i);
					Material filter = Material.getMaterial(blacklisted);
					
//					if (event.getAction() == InventoryAction.DROP_ONE_SLOT || event.getAction() == InventoryAction.DROP_ALL_SLOT || event.getAction() == InventoryAction.DROP_ALL_CURSOR || event.getAction() == InventoryAction.DROP_ONE_CURSOR) {
//						event.setCancelled(true);
//						Utils.sendMessage(p, "&cYou cannot have " + filter.toString().toLowerCase() + " &cinside of your inventory right now");
//					}
					if (event.getCurrentItem() == null || event.getCursor() == null) {
						event.setCancelled(true);
						
					}
					else if (!event.getCurrentItem().getType().equals(filter) || !event.getInventory().contains(filter) || !event.getCursor().getType().equals(filter)) {
						continue;
					}
					else if (event.getInventory().contains(filter) || event.getCurrentItem().getType().equals(filter) || event.getCursor().getType().equals(filter)) {
						event.setCancelled(true);
						event.getInventory().remove(filter);
						Utils.sendMessage(p, "&cYou cannot have " + filter.toString().toLowerCase() + " &cinside of your inventory right now");
					}
					else if (event.getClickedInventory().contains(filter)) {
						event.setCancelled(true);
						event.getInventory().remove(filter);
						Utils.sendMessage(p, "&cYou cannot have " + filter.toString().toLowerCase() + " &cinside of your inventory right now");
					}
					else {
						return;
					}
				}
			}
		}
	}
	
//	@EventHandler
//	public void onMove(PlayerMoveEvent event) {
//		Player p = (Player) event.getPlayer();
//		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) != null) {
//			if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
//				for (int i = 0; i < filterList.size(); i++) {
//					String blacklisted = filterList.get(i);
//					Material filter = Material.getMaterial(blacklisted);
//					if (p.getInventory().getContents() != null) {
//						if (p.getInventory().contains(filter)) {
//							event.setCancelled(true);
//							p.getInventory().remove(filter);
//							Utils.sendMessage(p, "&cYou cannot have " + filter.toString().toLowerCase() + " &cinside of your inventory right now");
//						}
//						else {
//							return;
//						}
//					}
//					else {
//						return;
//					}
//				}
//			}
//			return;
//		}
//	}
	
	@EventHandler
	public void onInventory5(InventoryCreativeEvent event) {
		Player p = (Player) event.getWhoClicked();
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) != null) {
			if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
				for (int i = 0; i < filterList.size(); i++) {
					String blacklisted = filterList.get(i);
					Material filter = Material.getMaterial(blacklisted);
					
					if (event.getAction() == InventoryAction.MOVE_TO_OTHER_INVENTORY || event.getAction() == InventoryAction.COLLECT_TO_CURSOR || event.getAction() == InventoryAction.DROP_ONE_SLOT || event.getAction() == InventoryAction.DROP_ALL_SLOT || event.getAction() == InventoryAction.DROP_ALL_CURSOR || event.getAction() == InventoryAction.DROP_ONE_CURSOR || event.getAction() == InventoryAction.CLONE_STACK) {
						event.setCancelled(true);
						Utils.sendMessage(p, "&cYou cannot have " + filter.toString().toLowerCase() + " &cinside of your inventory right now");
					}
					else if (event.getCurrentItem() == null || event.getCursor() == null) {
						event.setCancelled(true);
					}
					else if (!event.getCurrentItem().getType().equals(filter) || !event.getInventory().contains(filter) || !event.getCursor().getType().equals(filter)) {
						continue;
					}
					else if (event.getInventory().contains(filter) || event.getCurrentItem().getType().equals(filter) || event.getCursor().getType().equals(filter)) {
						event.setCancelled(true);
						event.getInventory().remove(filter);
						Utils.sendMessage(p, "&cYou cannot have " + filter.toString().toLowerCase() + " &cinside of your inventory right now");
					}
					else if (event.getClickedInventory().contains(filter)) {
						event.setCancelled(true);
						event.getInventory().remove(filter);
						Utils.sendMessage(p, "&cYou cannot have " + filter.toString().toLowerCase() + " &cinside of your inventory right now");
					}
					else {
						return;
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onInventory3(InventoryInteractEvent event) {
		Player p = (Player) event.getWhoClicked();
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) != null) {
			if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
				for (int i = 0; i < filterList.size(); i++) {
					String blacklisted = filterList.get(i);
					Material filter = Material.getMaterial(blacklisted);
					
					if (!event.getInventory().contains(filter)) {
						continue;
					}
					else {
						if (event.getInventory().contains(filter)) {
							event.setCancelled(true);
							event.getInventory().remove(filter);
							Utils.sendMessage(p, "&cYou cannot have " + filter.toString().toLowerCase() + " &cinside of your inventory right now");
						}
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onClick(PlayerInteractEvent event) {
		Player p = (Player) event.getPlayer();
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) != null) {
			if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
				if (event.getAction() == Action.RIGHT_CLICK_AIR || event.getAction() == Action.RIGHT_CLICK_BLOCK || event.getAction() == Action.LEFT_CLICK_AIR || event.getAction() == Action.LEFT_CLICK_BLOCK) {
					for (int i = 0; i < filterList.size(); i++) {
						String blacklisted = filterList.get(i);
						Material filter = Material.getMaterial(blacklisted);
						
						if (event.getPlayer().getItemInHand().getType().equals(filter)) {
							event.setCancelled(true);
							event.getPlayer().getInventory().remove(filter);
							Utils.sendMessage(p, "&cYou cannot have " + filter.toString().toLowerCase() + " &cinside of your inventory right now");
						}
						else {
							continue;
						}
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onConsume(PlayerItemConsumeEvent event) {
		Player p = (Player) event.getPlayer();
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) != null) {
			if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
				for (int i = 0; i < filterList.size(); i++) {
					String blacklisted = filterList.get(i);
					Material filter = Material.getMaterial(blacklisted);
					
					if (filter != event.getItem().getType()) {
						continue;
					}
					
					if (event.getItem().getType().equals(filter)) {
						event.setCancelled(true);
						event.getPlayer().getInventory().remove(filter);
						Utils.sendMessage(p, "&cYou cannot have " + filter.toString().toLowerCase() + " &cinside of your inventory right now");
					}
					else {
						return;
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onDrop(PlayerDropItemEvent event) {
		Player p = (Player) event.getPlayer();
		if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) != null) {
			if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
				event.setCancelled(true);
				Utils.sendMessage(p, "&cYou cannot drop items while building a warp.");
			}
		}
	}
}
