package str.playerwarps.listener;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.UUID;

import org.bukkit.Bukkit;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.OfflinePlayer;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.inventory.InventoryOpenEvent;
import org.bukkit.event.inventory.InventoryType;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import str.playerwarps.PlayerWarps;
import str.playerwarps.gui.ItemBuilder;
import str.playerwarps.gui.buttons.GUIButton;
import str.playerwarps.gui.types.PaginatedGUI;
import str.playerwarps.gui.types.PaginatedGUIAllPages;
import str.playerwarps.gui.types.PaginatedGUICP;
import str.playerwarps.util.Utils;
import str.playerwarps.util.Zone;

public class WarpBlockListener implements Listener {

	public static List<Location> placedBlock = new ArrayList<Location>();
	public static List<Location> walls = new ArrayList<Location>();
	
	@EventHandler
	public void onBlockBreak(BlockBreakEvent event) {
		Player p = event.getPlayer();
		if (p.getWorld() == Bukkit.getWorld("PlayerWarps-World")) {
			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
				Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
				for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
					UUID uuid = UUID.fromString(it.next());
					OfflinePlayer player = (OfflinePlayer) Bukkit.getOfflinePlayer(uuid);
					Location loc;
					Location loc2;
					Location loc3;
					if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + uuid.toString()) != null) {
						if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".xb") != null) {
							if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".yb") != null) {
								if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".zb") != null) {
									loc = Utils.getPlayerWarpLocation(player.getUniqueId().toString());
									if (Zone.contains(event.getPlayer().getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
										if (player.getName() == p.getName()) {
											if (Utils.getPlayerWarpLocation(p.getUniqueId().toString()) != null) {
												loc3 = Utils.getPlayerWarpLocation(p.getUniqueId().toString());
												if (Zone.contains(event.getPlayer().getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
													if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Approved") == null) {
														if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
															Block b = event.getBlock();
															ItemStack block = new ItemStack(b.getType(), 1, b.getData());
																
															if (b.getType() == Material.GLASS || b.getType() == Material.GLOWSTONE || b.getType() == Material.BEACON) {
																if (!placedBlock.contains(b.getLocation())) {
																	if (PlayerWarps.get().getWarpBox().testForWarpWalls(p, b) == "Disallow") {
																		Utils.sendMessage(p, "&cYou cannot break the perimeter of your warp.");
																		event.setCancelled(true);
																		return;
																	}
																	else if (PlayerWarps.get().getWarpBox().testForWarpWalls(p, b) == "SafeZone") {
																		Utils.sendMessage(p, "&cYou cannot break the warp safezone.");
																		event.setCancelled(true);
																		return;
																	}
																	event.setCancelled(true);
																	Utils.sendMessage(p, "&cYou cannot break this block.");
																}
															}
															else {
																if (placedBlock.contains(b.getLocation())) {
																	placedBlock.remove(b.getLocation());
																	return;
																}
																else {
																	if (PlayerWarps.get().getWarpBox().testForWarpWalls(p, b) == "Disallow") {
																		Utils.sendMessage(p, "&cYou cannot break the perimeter of your warp.");
																		event.setCancelled(true);
																		return;
																	}
																	else if (PlayerWarps.get().getWarpBox().testForWarpWalls(p, b) == "SafeZone") {
																		Utils.sendMessage(p, "&cYou cannot break the warp safezone.");
																		event.setCancelled(true);
																		return;
																	}
																	else if (PlayerWarps.get().getWarpBox().testForWarpWalls(p, b) == "Allow") {
																		return;
																	}
//			WORKING CODE FFS										Location loc1 = Utils.getPlayerWarpLocation(p.getUniqueId().toString()).subtract(24.500, 15.00000, -2.500);
//																	Location loc11 = loc1.clone().add(49, 58, 49);
//																	int xLow = Math.min(loc1.getBlockX(), loc11.getBlockX());
//																	int xHigh = Math.max(loc1.getBlockX(), loc11.getBlockX());
//																	
//																	int yLow = Math.min(loc1.getBlockY(), loc11.getBlockY());
//																	int yHigh = Math.max(loc1.getBlockY(), loc11.getBlockY());
//																	
//																	int zLow = Math.min(loc1.getBlockZ(), loc11.getBlockZ());
//																	int zHigh = Math.max(loc1.getBlockZ(), loc11.getBlockZ());
//																	
//																	
//																	
//																	for (int x = xLow; x <= xHigh; x++) {
//																		for (int y = yLow; y <= yHigh; y++) {
//																			for (int z = zLow; z <= zHigh - 1; z++) {
//																				if (x == zLow || y == zLow || z == zLow || x == xHigh - 1 || y == yHigh - 1 || z == zHigh) {
//																					if (b.getType() == Material.GRASS) {
//																						return;
//																					}
//																					if (b.getX() == x && b.getY() == y && b.getZ() == z) {
//																						Utils.sendMessage(p, "&cYou cannot break the perimeter of your warp.");
//																						event.setCancelled(true);
//																						return;
//																					}
//																				}
//																			}
//																		}
//																	}
																}
															}
														}
														else {
															event.setCancelled(true);
															Utils.sendMessage(p, "&cYou cannot break blocks inside of a playerwarp.");
														}
													}
													else {
														if (p.hasPermission("playerwarps.bypass-regions")) {
															return;
														}
														else {
															event.setCancelled(true);
															Utils.sendMessage(p, "&cYou cannot break blocks inside of a playerwarp.");
														}
													}
												}
											}
										}
										else {
											if (p.hasPermission("playerwarps.bypass-regions")) {
												return;
											}
											else {
												event.setCancelled(true);
												Utils.sendMessage(p, "&cYou cannot break blocks inside of a playerwarp.");
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	
	@EventHandler
	public void onBlockPlace(BlockPlaceEvent event) {
		Player p = event.getPlayer();
		if (p.getWorld() == Bukkit.getWorld("PlayerWarps-World")) {
			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
				Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
				for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
					UUID uuid = UUID.fromString(it.next());
					OfflinePlayer player = (OfflinePlayer) Bukkit.getOfflinePlayer(uuid);
					Location loc;
					Location loc2;
					Location loc3;
					if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + uuid.toString()) != null) {
						if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".xb") != null) {
							if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".yb") != null) {
								if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + uuid.toString() + ".zb") != null) {
									loc = Utils.getPlayerWarpLocation(player.getUniqueId().toString());
									if (Zone.contains(event.getPlayer().getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
										if (player.getName() == p.getName()) {
											if (Utils.getPlayerWarpLocation(p.getUniqueId().toString()) != null) {
												loc3 = Utils.getPlayerWarpLocation(p.getUniqueId().toString());
												if (Zone.contains(event.getPlayer().getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
													if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Approved") == null) {
														if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
															Block b = event.getBlock();
															if (b.getType() == Material.GLASS || b.getType() == Material.GLOWSTONE) {
																if (!placedBlock.contains(b.getLocation())) {
																	if (PlayerWarps.get().getWarpBox().testForWarpWalls(p, b) == "Disallow") {
																		Utils.sendMessage(p, "&cYou cannot build on the perimeter of your warp.");
																		event.setCancelled(true);
																		return;
																	}
																	else if (PlayerWarps.get().getWarpBox().testForWarpWalls(p, b) == "SafeZone") {
																		Utils.sendMessage(p, "&cYou cannot build in the warp safezone.");
																		event.setCancelled(true);
																		return;
																	}
																	placedBlock.add(b.getLocation());
																}
															}
															else {
																if (PlayerWarps.get().getWarpBox().testForWarpWalls(p, b) == "Disallow") {
																	Utils.sendMessage(p, "&cYou cannot build on the perimeter of your warp.");
																	event.setCancelled(true);
																	return;
																}
																else if (PlayerWarps.get().getWarpBox().testForWarpWalls(p, b) == "SafeZone") {
																	Utils.sendMessage(p, "&cYou cannot build in the warp safezone.");
																	event.setCancelled(true);
																	return;
																}
																else if (PlayerWarps.get().getWarpBox().testForWarpWalls(p, b) == "Allow") {
																	return;
																}
															}
														}
														else {
															event.setCancelled(true);
															Utils.sendMessage(p, "&cYou cannot place blocks inside of a playerwarp.");
														}
													}
													else {
														if (p.hasPermission("playerwarps.bypass-regions")) {
															return;
														}
														else {
															event.setCancelled(true);
															Utils.sendMessage(p, "&cYou cannot place blocks inside of a playerwarp.");
														}
													}
												}
											}
										}
										else {
											if (p.hasPermission("playerwarps.bypass-regions")) {
												return;
											}
											else {
												event.setCancelled(true);
												Utils.sendMessage(p, "&cYou cannot place blocks inside of a playerwarp.");
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	
//	@EventHandler
//	public void onChestOpen(PlayerInteractEvent event) {
//		Player p = (Player) event.getPlayer();
//		if (event.getItem() == null || event.getItem().getType() == Material.AIR) return;
//		if (event.getClickedBlock().getType() == Material.CHEST || event.getClickedBlock().getType() == Material.ENDER_CHEST || event.getClickedBlock().getType() == Material.TRAPPED_CHEST) {
//			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) != null) {
//				if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
//					event.setCancelled(true);
//					Utils.sendMessage(p, "&cYou cannot open containers inside of a playerwarp.");
//				}
//			}
//		}
//	}
//	
//	@EventHandler
//	public void onBeaconOpen(PlayerInteractEvent event) {
//		Player p = (Player) event.getPlayer();
//		if (event.getItem() == null || event.getItem().getType() == Material.AIR) return;
//		if (event.getClickedBlock().getType() == Material.CHEST || event.getClickedBlock().getType() == Material.ENDER_CHEST || event.getClickedBlock().getType() == Material.TRAPPED_CHEST) {
//			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) != null) {
//				if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("true")) {
//					event.setCancelled(true);
//					Utils.sendMessage(p, "&cYou cannot open containers inside of a playerwarp.");
//				}
//			}
//		}
//		if (event.getClickedBlock().getType() == Material.BEACON) {
//			event.setCancelled(true);
//			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
//				if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) != null) {
//					if (Utils.getPlayerWarpLocation(p.getUniqueId().toString()) != null) {
//						Set<String> set = PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By").getKeys(false);
//						for (Iterator<String> it = set.iterator(); it.hasNext(); ) {
//							UUID uuid = UUID.fromString(it.next());
//							OfflinePlayer player = (OfflinePlayer) Bukkit.getOfflinePlayer(uuid);
//							Location loc = Utils.getPlayerWarpLocation(uuid.toString());
//							if (Zone.contains(p.getLocation(), loc.getBlockX() + 25, loc.getBlockX() + 20 - 69, -7, 66)) {
//								if (player.getUniqueId() == p.getUniqueId()) {
//									if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Building").equalsIgnoreCase("false")) {
//										PaginatedGUICP controlPanel = new PaginatedGUICP("Warp Create: Control Panel");
//										GUIButton glassPane = new GUIButton(ItemBuilder.start(Material.STAINED_GLASS_PANE).data((short)15).name(" ").build());
//										glassPane.setListener(event1 -> {
//											event1.setCancelled(true);
//										});
//										for (int i = 0; i < 10; i++) {
//											controlPanel.setButton(i, glassPane);
//										}
//										List<String> infoLore = new ArrayList<String>();
//										if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Need-Approval") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Need-Approval").equalsIgnoreCase("false")) {
//											infoLore.add("&7Status: &aApproved");
//										}
//										else {
//											infoLore.add("&7Status: &cUnapproved");
//										}
//										if (Utils.getEditTime(p.getUniqueId().toString()) != 0) {
//											infoLore.add("&7Banked Edit Time: &f" + Utils.formatSeconds(Long.valueOf(Utils.getEditTime(p.getUniqueId().toString()))));
//										}
//										else {
//											infoLore.add("&7Banked Edit Time: &f" + Utils.getEditTime(p.getUniqueId().toString()) + "s");
//										}
//										GUIButton info = new GUIButton(ItemBuilder.start(Material.PAPER).name("&a&lInformation").lore(infoLore).build());
//										info.setListener(event2 -> {
//											event2.setCancelled(true);
//										});
//										controlPanel.addButton(info);
//										for (int i = 11; i < 15; i++) {
//											controlPanel.setButton(i, glassPane);
//										}
//										List<String> transactionsLore = new ArrayList<String>();
//										transactionsLore.add("&7The last 10 time transactions of your warp,");
//										transactionsLore.add("&7this is sorted latest to oldest.");
//										if (Utils.getTransactions(p.getUniqueId().toString()) != false) {
//											transactionsLore.add("");
//											List<String> t = (List<String>) PlayerWarps.get().getCustomData().getStringList("Warp-Edit-Transactions." + p.getUniqueId().toString());
//											int count = 1;
//											for (int i = 0; i < PlayerWarps.get().getCustomData().getStringList("Warp-Edit-Transactions." + p.getUniqueId().toString()).size(); i++) {
//												transactionsLore.add("&e&l" + count + ") " + PlayerWarps.get().getCustomData().getStringList("Warp-Edit-Transactions." + p.getUniqueId().toString()).get(i));
//												count++;
//											}
//										}
//										GUIButton transactions = new GUIButton(ItemBuilder.start(Material.EMPTY_MAP).name("&a&lTransactions").lore(transactionsLore).build());
//										transactions.setListener(event3 -> {
//											event3.setCancelled(true);
//										});
//										controlPanel.addButton(transactions);
//										List<String> editWarpLore = new ArrayList<String>();
//										if (Utils.getEditTime(p.getUniqueId().toString()) == 0) {
//											editWarpLore.add("");
//											editWarpLore.add("&7You currently cannot start editing your warp");
//											editWarpLore.add("&7as you have no edit time available.");
//											editWarpLore.add("");
//											editWarpLore.add("&c[You must have remaining time to edit your warp]");
//										}
//										else {
//											editWarpLore.add("");
//											editWarpLore.add("&7This will allow you to enter edit mode on your warp.");
//											editWarpLore.add("&7Time Remaining: &f" + Utils.formatSeconds(Long.valueOf(Utils.getEditTime(p.getUniqueId().toString()))));
//											editWarpLore.add("");
//											editWarpLore.add("&a[Click to start editing your warp]");
//										}
//										GUIButton editWarp = new GUIButton(ItemBuilder.start(Material.BOOK_AND_QUILL).name("&a&lEdit Warp").lore(editWarpLore).build());
//										editWarp.setListener(event4 -> {
//											event4.setCancelled(true);
//											if (event4.getRawSlot() < event4.getInventory().getSize()) {
//												if (Utils.getEditTime(p.getUniqueId().toString()) != 0) {
//													if (p.getOpenInventory() != null) p.closeInventory();
//													PlayerWarps.get().getWorldSetup().createVoidWorld(p, true, Utils.getEditTime(p.getUniqueId().toString()));
//												}
//											}
//										});
//										controlPanel.addButton(editWarp);
//										for (int i = 17; i < 27; i++) {
//											controlPanel.setButton(i, glassPane);
//										}
//										p.openInventory(controlPanel.getInventory());
//									}
//									else {
//										PaginatedGUICP controlPanel = new PaginatedGUICP("Warp Create: Control Panel");
//										GUIButton glassPane = new GUIButton(ItemBuilder.start(Material.STAINED_GLASS_PANE).data((short)15).name(" ").build());
//										glassPane.setListener(event1 -> {
//											event1.setCancelled(true);
//										});
//										for (int i = 0; i < 10; i++) {
//											controlPanel.setButton(i, glassPane);
//										}
//										List<String> infoLore = new ArrayList<String>();
//										if (PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Need-Approval") != null && PlayerWarps.get().getCustomData().getString("Warps-Created-By." + p.getUniqueId().toString() + ".Need-Approval").equalsIgnoreCase("false")) {
//											infoLore.add("&7Status: &aApproved");
//										}
//										else {
//											infoLore.add("&7Status: &cUnapproved");
//										}
//										if (Utils.getEditTime(p.getUniqueId().toString()) != 0) {
//											infoLore.add("&7Banked Edit Time: &f" + Utils.formatSeconds(Long.valueOf(Utils.getEditTime(p.getUniqueId().toString()))));
//										}
//										else {
//											infoLore.add("&7Banked Edit Time: &f" + Utils.getEditTime(p.getUniqueId().toString()) + "s");
//										}
//										GUIButton info = new GUIButton(ItemBuilder.start(Material.PAPER).name("&a&lInformation").lore(infoLore).build());
//										info.setListener(event2 -> {
//											event2.setCancelled(true);
//										});
//										controlPanel.addButton(info);
//										controlPanel.addButton(glassPane);
//										GUIButton editSpawnRoomWalls = new GUIButton(ItemBuilder.start(Material.BRICK).name("&e&lComing Soon").build());
//										editSpawnRoomWalls.setListener(event3 -> {
//											event3.setCancelled(true);
//										});
//	//									List<String> spawnRoomWallsLore = new ArrayList<String>();
//	//									spawnRoomWallsLore.add("&7Change what the wall material composition");
//	//									spawnRoomWallsLore.add("&7of your warp are made out of.");
//	//									spawnRoomWallsLore.add("");
//	//									spawnRoomWallsLore.add("&a[Left click to edit Spawn Room walls]");
//	//									GUIButton editSpawnRoomWalls = new GUIButton(ItemBuilder.start(Material.BRICK).name("&e&lEdit Spawn Room Walls").lore(spawnRoomWallsLore).build());
//	//									editSpawnRoomWalls.setListener(event3 -> {
//	//										event3.setCancelled(true);
//	//										if (event3.getRawSlot() < event3.getInventory().getSize()) {
//	//											PaginatedGUIAllPages controlPanelSR = new PaginatedGUIAllPages("Warp Create Walls: Spawn Room");
//	//											PaginatedGUI.inSubMenu.put(p, true);
//	//											for (int i = 0; i < 4; i++) {
//	//												controlPanelSR.setButton(i, glassPane);
//	//											}
//	//											GUIButton paper = new GUIButton(ItemBuilder.start(Material.PAPER).build());
//	//											paper.setListener(e -> {
//	//												e.setCancelled(true);
//	//											});
//	//											controlPanelSR.addButton(paper);
//	//											for (int i = 0; i < 19; i++) {
//	//												controlPanelSR.setButton(i, glassPane);
//	//											}
//	//											double chance = 100;
//	////											if (controlPanelSR.getButton(19) != null) {
//	////												chance = 100 / 2;
//	////											}
//	////											else {
//	////												chance = 100;
//	////											}
//	////											if (controlPanelSR.getButton(20) != null) {
//	////												chance = 100 / 3;
//	////											}
//	////											else {
//	////												chance = 100 / 2;
//	////											}
//	//											List<String> blockLore = new ArrayList<String>();
//	//											blockLore.add("&7Usage Chance: &a" + chance + "%");
//	//											blockLore.add("");
//	//											blockLore.add("&c[Click to remove]");
//	//											GUIButton glass = new GUIButton(ItemBuilder.start(Material.GLASS).lore(blockLore).build());
//	//											glass.setListener(e2 -> {
//	//												e2.setCancelled(true);
//	//												if (e2.getRawSlot() < e2.getInventory().getSize()) {
//	//													if (controlPanelSR.getButton(21) != null || controlPanelSR.getButton(22) != null || controlPanelSR.getButton(23) != null || controlPanelSR.getButton(24) != null || controlPanelSR.getButton(25) != null || controlPanelSR.getButton(26) != null) {
//	//														controlPanelSR.removeButton(20);
//	//													}
//	//													else {
//	//														Utils.sendMessage(p, "&cYou cannot remove this as their has to be at least 1 block selected.");
//	//													}
//	//												}
//	//											});
//	//											for (int i = 27; i < 36; i++) {
//	//												controlPanelSR.setButton(i, glassPane);
//	//											}
//	//											controlPanelSR.setCloseListener(e1 -> {
//	//												Bukkit.getScheduler().runTaskLater(PlayerWarps.get(), new Runnable() {
//	//							    					public void run() {
//	//							    						if (PaginatedGUI.inSubMenu.get(p) == true) {
//	//							    							PaginatedGUI.inSubMenu.remove(p);
//	//							    						}
//	//							    						if (p.getOpenInventory() != null) p.closeInventory();
//	//							    						p.openInventory(controlPanel.getInventory());
//	//							    						Utils.sendMessage(p, "&e&lWarp Create &aSpawn room walls have been updated!");
//	//							    					}
//	//							    				}, 1L);
//	//											});
//	//										}
//	//									});
//	//									controlPanel.addButton(editSpawnRoomWalls);
//										controlPanel.addButton(editSpawnRoomWalls);
//										controlPanel.addButton(glassPane);
//										GUIButton editWarpRoomWalls = new GUIButton(ItemBuilder.start(Material.BRICK).name("&e&lComing Soon").build());
//										editWarpRoomWalls.setListener(event4 -> {
//											event4.setCancelled(true);
//										});
//	//									List<String> warpRoomWallsLore = new ArrayList<String>();
//	//									warpRoomWallsLore.add("&7Change what the wall material composition");
//	//									warpRoomWallsLore.add("&7of your warp are made out of.");
//	//									warpRoomWallsLore.add("");
//	//									warpRoomWallsLore.add("&a[Left click to edit Warp Room walls]");
//	//									GUIButton editWarpRoomWalls = new GUIButton(ItemBuilder.start(Material.BRICK).name("&e&lEdit Warp Room Walls").lore(warpRoomWallsLore).build());
//	//									editWarpRoomWalls.setListener(event4 -> {
//	//										event4.setCancelled(true);
//	//										if (event4.getRawSlot() < event4.getInventory().getSize()) {
//	//											PaginatedGUIAllPages controlPanelSR = new PaginatedGUIAllPages("Warp Create Walls: Warp Room");
//	//											PaginatedGUI.inSubMenu.put(p, true);
//	//											for (int i = 0; i < 4; i++) {
//	//												controlPanelSR.setButton(i, glassPane);
//	//											}
//	//											GUIButton paper = new GUIButton(ItemBuilder.start(Material.PAPER).build());
//	//											paper.setListener(e -> {
//	//												e.setCancelled(true);
//	//											});
//	//											controlPanelSR.addButton(paper);
//	//											for (int i = 0; i < 19; i++) {
//	//												controlPanelSR.setButton(i, glassPane);
//	//											}
//	//											double chance = 100;
//	////											if (controlPanelSR.getButton(19) != null) {
//	////												chance = 100 / 2;
//	////											}
//	////											else {
//	////												chance = 100;
//	////											}
//	////											if (controlPanelSR.getButton(20) != null) {
//	////												chance = 100 / 3;
//	////											}
//	////											else {
//	////												chance = 100 / 2;
//	////											}
//	//											List<String> blockLore = new ArrayList<String>();
//	//											blockLore.add("&7Usage Chance: &a" + chance + "%");
//	//											blockLore.add("");
//	//											blockLore.add("&c[Click to remove]");
//	//											GUIButton glass = new GUIButton(ItemBuilder.start(Material.GLASS).lore(blockLore).build());
//	//											glass.setListener(e2 -> {
//	//												e2.setCancelled(true);
//	//												if (e2.getRawSlot() < e2.getInventory().getSize()) {
//	//													if (controlPanelSR.getButton(21) != null || controlPanelSR.getButton(22) != null || controlPanelSR.getButton(23) != null || controlPanelSR.getButton(24) != null || controlPanelSR.getButton(25) != null || controlPanelSR.getButton(26) != null) {
//	//														controlPanelSR.removeButton(20);
//	//													}
//	//													else {
//	//														Utils.sendMessage(p, "&cYou cannot remove this as their has to be at least 1 block selected.");
//	//													}
//	//												}
//	//											});
//	//											controlPanelSR.addButton(glass);
//	//											for (int i = 27; i < 36; i++) {
//	//												controlPanelSR.setButton(i, glassPane);
//	//											}
//	//											controlPanelSR.setCloseListener(e1 -> {
//	//												Bukkit.getScheduler().runTaskLater(PlayerWarps.get(), new Runnable() {
//	//							    					public void run() {
//	//							    						if (PaginatedGUI.inSubMenu.get(p) == true) {
//	//							    							PaginatedGUI.inSubMenu.remove(p);
//	//							    						}
//	//							    						if (p.getOpenInventory() != null) p.closeInventory();
//	//							    						p.openInventory(controlPanel.getInventory());
//	//							    						Utils.sendMessage(p, "&e&lWarp Create &aWarp room walls have been updated!");
//	//							    					}
//	//							    				}, 1L);
//	//											});
//	//											if (p.getOpenInventory() != null) p.closeInventory();
//	//											p.openInventory(controlPanelSR.getInventory());
//	//										}
//	//									});
//										controlPanel.addButton(editWarpRoomWalls);
//										controlPanel.addButton(glassPane);
//										List<String> editWarpLore = new ArrayList<String>();
//										editWarpLore.add("");
//										editWarpLore.add("&7This will make it so you stop editing your warp,");
//										editWarpLore.add("&7and it will withdraw however much time you've used,");
//										editWarpLore.add("&7and store the remaining time for further use.");
//										editWarpLore.add("");
//										editWarpLore.add("&a[Click to stop editing your warp]");
//										GUIButton editWarp = new GUIButton(ItemBuilder.start(Material.BOOK_AND_QUILL).name("&e&lStop Editing").lore(editWarpLore).build());
//										editWarp.setListener(event5 -> {
//											event5.setCancelled(true);
//											if (event5.getRawSlot() < event5.getInventory().getSize()) {
//												if (p.getOpenInventory() != null) p.closeInventory();
//												Utils.removeWarpBuilding(p.getUniqueId().toString());
//											}
//										});
//										controlPanel.addButton(editWarp);
//										for (int i = 17; i < 27; i++) {
//											controlPanel.setButton(i, glassPane);
//										}
//										p.openInventory(controlPanel.getInventory());
//										return;
//									}
//								}
//							}
//							else {
//								Utils.sendMessage(p, "&cYou must be the owner of this warp create to access the control panel.");
//								return;
//							}
//						}
//					}
//					else {
//						Utils.sendMessage(p, "&cYou must be the owner of this warp create to access the control panel.");
//						return;
//					}
//				}
//			}
//		}
//	}
	
	@EventHandler
	public void onInteract(PlayerInteractEvent event) {
		Player p = event.getPlayer();
		if (event.getItem() == null || event.getItem().getType() == Material.AIR) {
			return;
		}
		if (p.getWorld() == Bukkit.getWorld("PlayerWarps-World")) {
			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By") != null) {
				if (event.getItem().getType() == Material.WATER_BUCKET || event.getItem().getType() == Material.LAVA_BUCKET) {
					if (p.hasPermission("playerwarps.bypass-regions")) {
						return;
					}
					else {
						event.setCancelled(true);
						Utils.sendMessage(p, "&cYou cannot place liquids inside of a playerwarp.");
					}
				}
			}
		}
//		else if (p.getWorld().getName().startsWith("PlayerWarp") && !p.getWorld().getName().contains(p.getUniqueId().toString())) {
//			if (PlayerWarps.get().getCustomData().getConfigurationSection("Warps-Created-By." + p.getUniqueId().toString()) == null) {
//				if (event.getItem().getType() == Material.WATER_BUCKET || event.getItem().getType() == Material.LAVA_BUCKET) {
//					if (p.hasPermission("playerwarps.bypass-regions")) {
//						return;
//					}
//					else {
//						event.setCancelled(true);
//						Utils.sendMessage(p, "&cYou cannot place blocks inside of a playerwarp.");
//					}
//				}
//			}
//			else {
//				if (event.getItem().getType() == Material.WATER_BUCKET || event.getItem().getType() == Material.LAVA_BUCKET) {
//					if (p.hasPermission("playerwarps.bypass-regions")) {
//						return;
//					}
//					else {
//						event.setCancelled(true);
//						Utils.sendMessage(p, "&cYou cannot place blocks inside of a playerwarp.");
//					}
//				}
//			}
//		}
		}
}
